#ifndef _PARAMADUTILS_H_
#define _PARAMADUTILS_H_
/*
  ------------------------------------------------------------- 
  File paramadutils.h of non-standard ADOL-C version 1.7 as of Feb/09/98
  Included in ---> paramdrivers.c

  -------------------------------------------------------------
  Contains the definitions of the paramaccode and paramforode for 
  ADOL-C.  These routines are defined in paramdrivers.c.
*/

/* DS. 18.9.95 return type changed to int for forward sweeps and ODE-drivers  */


extern "C" {
#include "paramadutilsc.h"
}


/* Memory management routines. */

/* extern double ** myalloc(int,int);
   extern double *** myalloc(int,int,int); */



/* paramforode(tag,n,m,tau,dold,dnew,X[n][d+1]) */

int paramforode(short,int,int,double,int,int,double**);

/* the scaling defaults to 1 */

int paramforode(short,int,int,/*1.0*/ int,int,double**);

/* previous order defaults to 0 */

int paramforode(short,int,int,double,/*0*/ int,double**);

/* both default */

int paramforode(short,int,int,/*1.0 , 0*/int,double**);

/* paramaccode(n,m,tau,d,Z,B,nz) */

void paramaccode(int,int,double,int,double***,double***,short** = 0 );

/* scaling defaults to 1 */

void paramaccode(int,int,/*1.0*/ int,double***,double***,short** = 0 );

#endif
