#include <math.h>
#ifdef __cplusplus

#include "adouble.h"
#include "adutils.h"

#endif

#ifdef __cplusplus

void cubic(unsigned short tag, double *px, double *pxp, double *p)
{
    adouble x[2];
    adouble xp[2];
    int i;

    trace_on(tag);
    for (i=0;i<2;i++)
   	x[i] <<= px[i];

    xp[0] = x[1];
    xp[1] = -( x[0]*x[0]*x[0] + p[0]*x[0]*x[0] + p[1]*x[0] + p[2] ) + x[1]*(p[3] - x[0]*x[0]);

    for (i=0;i<2;i++)
	xp[i] >>= pxp[i];

    trace_off();

}


#endif

void cubic(double *px, double *pxp, double *p)
{
    double x[2];    
    double xp[2];
    int i;
 
    for (i=0;i<2;i++)        
        x[i] = px[i];
 
    xp[0] = x[1];
    xp[1] = -( x[0]*x[0]*x[0] + p[0]*x[0]*x[0] + p[1]*x[0] + p[2] ) + x[1]*(p[3] - x[0]*x[0]);
 
    for (i=0;i<2;i++)
        pxp[i] = xp[i];
 
 
}


