#include "mex.h"
#define dim 2
#define DIMLOOP(i) for(i=0;i<dim;i++)

static double **J;
static int allocated = 0;

void mexFunction(
                 int nlhs,       mxArray *plhs[],
                 int nrhs, const mxArray *prhs[]
		 )
{
	int i,j;
	double *p1,*p2,*p3;
	double z[dim],p[dim];

	if(nrhs == 0) return;

	p1 = mxGetPr(prhs[0]);
	DIMLOOP(i) z[i] = p1[i];

        p3 = mvGetPr(prhs[1]);

	if(!allocated){
		J = (double **)malloc(dim*sizeof(double *));
		DIMLOOP(i) J[i] = (double *) malloc(sizeof(double)*dim);
		allocated = 1;
	}

	cubic_jacobian(z,J,p3);
	plhs[0] = mxCreateDoubleMatrix(dim,dim,mxREAL);
	p2 = mxGetPr(plhs[0]);
	DIMLOOP(i)
		DIMLOOP(j) p2[i+j*dim] = J[i][j];

}
