/*
   --------------------------------------------------------------
   driver.C 
   --------------------------------------------------------------
*/

#include <stream.h>
#include <stdio.h>

#ifdef __GNUG__
#include <std.h>
#else
#include <stdlib.h>
#endif

/*  This program tests the implementation of the param* routines.  
 *  Essentially, their purpose is to compute the derivatives of Taylor
 *  coefficients of paths with respect to parameters.  
 */

#include "adouble.h"    // These includes provide the compiler with
#include "adutils.h"    // definitions and utilities for `adoubles'.
#include "paramadutils.h"  // definitions of param* routines.

#define dim 2
#define fulldim 6
#define fixeddeg 7
#define DIMLOOP(x) for(x=0;x<tdim;x++)
#define DEGLOOP(x) for(x=0;x<=fixeddeg;x++)

extern "C" {

extern void t(int nlhs, double *plhs0, double *plhs1, int deg, int nrhs, double **prhs0, double ***prhs1);
extern void fullt(int nlhs, double *plhs0, double *plhs1, int deg, int nrhs, double **prhs0, double **prhs1, double ***prhs2);

/*
double *x, *zz, *pyp;
double **Taylor, ***Jac, ***A;
short **nonzero;

double *xg, *zzg, *pypg;
double **Taylorg, ***Jacg, ***Ag;
short **nonzerog;
*/


int main() 
{
    double data[2],params[4];
    double **prhs0, **prhs1, ***prhs2;
    int i,j,k;
  
    prhs0 = myalloc2(fulldim,fixeddeg+1);
    prhs1 = myalloc2(fulldim,fixeddeg+1);
    prhs2 = myalloc3(fulldim,fulldim,fixeddeg+1); 

    data[0] = 0.0;
    data[1] = 0.647113;
    params[0] = 0.0;
    params[1] = -1.0;
    params[2] = 0.0;
    params[3] = 0.78;

    t(2,data,params,fixeddeg,3,prhs0,prhs2);
/*
    for (i=0;i<fulldim;i++){
	for (j=0;j<fulldim;j++){	
	    for (k=0;k<fixeddeg+1;k++){
		printf ("%lf \n", prhs2[i][j][k]);
		}
	    printf ("\n");
	    }
	}
    printf("\n");

    for (i=0;i<fulldim;i++){
        for (j=0;j<fulldim;j++){        
            for (k=0;k<fixeddeg+1;k++){
                printf ("%lf \n", prhs1[i][j][k]);                        
                }                
            printf ("\n");
            }   
        }
    printf("\n");

    for (i=0;i<fulldim;i++){
	for (j=0;j<fixeddeg+1;j++){
	    printf ("%lf \n", prhs0[i][j]);
	    }
	printf ("\n");
	}
 */   
    fullt(2,data,params,fixeddeg,3,prhs0,prhs1,prhs2); 
/*
    for (i=0;i<fulldim;i++){
        for (j=0;j<fulldim;j++){
            for (k=0;k<fixeddeg+1;k++){
                printf ("%lf \n", prhs2[i][j][k]);
                }
            printf ("\n");
            }
        }
    printf("\n");
 
    for (i=0;i<fulldim;i++){
        for (j=0;j<fulldim;j++){        
            for (k=0;k<fixeddeg+1;k++){
                printf ("%lf \n", prhs1[i][j][k]);                        
                }                
            printf ("\n");
            }   
        }
    printf("\n");
 
    for (i=0;i<fulldim;i++){
        for (j=0;j<fixeddeg+1;j++){
            printf ("%lf \n", prhs0[i][j]);
            }
        printf ("\n");
        }
*/ 
    
    

}

}
