/*
 * fullt.C 
 */ 

// #include <stream.h>
// #include <stdio.h>
 
//#ifdef __GNUG__
//#include <std.h>
//#else
//#include <stdlib.h>
//#endif

extern "C" {
typedef int bool;
#include <matrix.h>
#include <math.h>
}

#include "adouble.h"
#include "adutils.h"
#include "paramadutils.h"

#define dim 2
#define fulldim 6
#define DIMLOOP(x) for(x=0;x<fulldim;x++)
#define DEGLOOP(x) for(x=0;x<=deg;x++)

void fullcubic(double*,double*,double*);
void fullcubic(unsigned short,double*,double*,double*);

/*
static int allocated = 0;
static double *x,*pyp,*params;
static double **Taylor,***Jac,***A;
static short **nonzero;
*/

extern "C" {

	static int allocated = 0;
	static double *x,*pyp,*params;
	static double **Taylor,***Jac,***A;
	static short **nonzero;

	extern void mexErrMsgTxt(const char *);

	void allocate()
	{
		int i;

		if(allocated) return;
		x = myalloc1(dim);
		pyp = myalloc1(dim);
		params = myalloc1(fulldim-dim);
		Taylor = myalloc2(fulldim,50);
		Jac = myalloc3(dim,fulldim,50);
		A = myalloc3(dim,fulldim,50);
//		nonzero = new short*[fulldim];
//		DIMLOOP(i) nonzero[i] = new short[dim];

		allocated = 1;
	}

	void fullt(int nlhs, double *plhs0, double *plhs1, int deg, int nrhs, double **prhs0, double **prhs1, double ***prhs2)
	{
		double delta;
		mxArray *cell_ptr;
		int i,j,k,index;
		int subs[2];

		allocate();

// Store initial point

		for (i=0;i<dim;i++){
		     Taylor[i][0] = plhs0[i];
		     x[i] = plhs0[i];
		     }

// and parameters
		for (i=dim;i<fulldim;i++){
		     Taylor[i][0] = plhs1[i-dim];
		     params[i-dim] = plhs1[i-dim];
		     }
		
// and degree

		printf ("\n%d\n", deg);
		for (i=0;i<4;i++) printf ("%lf ", params[i]); 
		for (i=0;i<2;i++) printf ("%lf ", x[i]);
		printf ("\n");



// ADOL-C calculation

		delta = 1.0;
		fullcubic(1,x,pyp,params);
                for (i=0;i<4;i++) printf ("%lf ", params[i]);
                for (i=0;i<2;i++) printf ("%lf ", x[i]);
                printf ("\n");

		paramforode(1,fulldim,dim,delta,deg+1,Taylor);
                for (i=0;i<4;i++) printf ("%lf ", params[i]);
                for (i=0;i<2;i++) printf ("%lf ", x[i]);
                printf ("\n");

		reverse(1,dim,fulldim,deg,A);
                for (i=0;i<4;i++) printf ("%lf ", params[i]);
                for (i=0;i<2;i++) printf ("%lf ", x[i]);
                printf ("\n");

		paramaccode(fulldim,dim,delta,deg,A,Jac);
                for (i=0;i<4;i++) printf ("%lf ", params[i]);
                for (i=0;i<2;i++) printf ("%lf ", x[i]);
                printf ("\n");



            for (k=0;k<deg;k++){
                for (j=0;j<fulldim;j++)
                    printf ("%lf ", Taylor[j][k]);
                printf("\n");
                }
      	    printf ("\n"); 

                for (i=0;i<dim;i++){
                    for (j=0;j<fulldim;j++)
                        printf ("%lf ", Jac[i][j][1]);
                    printf ("\n");
                    }


// Store taylor series into a MATLAB variable
/*
		for(i=0;i<dim;i++) for(j=0;j<=deg;j++) plhs0[j+i*(deg+1)] = Taylor[i][j];

*/
// Store Jacobian path into a MATLAB Cell Array
/*
		for(i=0;i<=deg;i++){
			subs[0] = 0; 
			subs[1] = i;
			index = mxCalcSingleSubscript(plhs[1],2,subs);
			cell_ptr = mxCreateDoubleMatrix(dim,dim,mxREAL);
			for(j=0; j<dim; j++) for(k=0; k<dim; k++) p1[j+k*dim] = Jac[j][k][i];
			mxSetCell(plhs[1],index,cell_ptr);
		}
*/
// Store Jacobian WRT parameters into a MATLAB variable
/*
		plhs[2] = mxCreateDoubleMatrix(dim,fulldim-dim,mxREAL);

		p1 = mxGetPr(plhs[2]);
		for (i=dim;i<fulldim;i++)
		    for (j=0;j<dim;j++)
		        p1[(i-dim)*dim+j] = Jac[j][i][1];
*/
	}

}

