extern "C" {
typedef int bool;
#include <matrix.h>
#include <math.h>
}

#include "adouble.h"
#include "adutils.h"

#define dim 2
#define fulldim 6
#define DIMLOOP(x) for(x=0;x<dim;x++)

void cubic(double*,double*,double*);
void cubic(unsigned short,double*,double*,double*);

extern "C" {

	static int tallocated = 0;
	static double *tx,*tzz,*tpyp;
	static double **tTaylor,***tJac,***tA;
	static short **tnonzero;

	void tallocate()
	{
		int i;

		if(tallocated) return;
		tx = myalloc1(dim);
		tzz = myalloc1(dim);
		tpyp = myalloc1(dim);
		tTaylor = myalloc2(dim,50);
		tJac = myalloc3(dim,dim,50);
		tA = myalloc3(dim,dim,50);
		tnonzero = new short*[dim];
		DIMLOOP(i) tnonzero[i] = new short[dim];

		tallocated = 1;
	}

	void t(int nlhs, double *plhs0, double *plhs1, int deg, int nrhs, double **prhs0, double ***prhs1)
	{
		double delta;
		int i,j,k,index;
		int subs[2];

		tallocate();

// Store initial point

		DIMLOOP(i) tTaylor[i][0] = tx[i] = plhs0[i];

// and parameters
		
// and degree


		printf ("\n%d \n", deg);
		for (i=0;i<4;i++) printf ("%lf ", plhs1[i]);
		for (i=0;i<2;i++) printf ("%lf ", tx[i]);
		printf ("\n");


// ADOL-C calculation

		delta = 1.0;
		cubic(0,tx,tpyp,plhs1);
                for (i=0;i<4;i++) printf ("%lf ", plhs1[i]);
                for (i=0;i<2;i++) printf ("%lf ", tx[i]);
                printf ("\n");

		forode(0,dim,delta,deg+1,tTaylor);
                for (i=0;i<4;i++) printf ("%lf ", plhs1[i]);
                for (i=0;i<2;i++) printf ("%lf ", tx[i]);
                printf ("\n");

		reverse(0,dim,dim,deg,tA,tnonzero);
                for (i=0;i<4;i++) printf ("%lf ", plhs1[i]);
                for (i=0;i<2;i++) printf ("%lf ", tx[i]);
                printf ("\n");

		accode(dim,delta,deg,tA,tJac,tnonzero);
                for (i=0;i<4;i++) printf ("%lf ", plhs1[i]);
                for (i=0;i<2;i++) printf ("%lf ", tx[i]);
                printf ("\n");


            for (k=0;k<deg;k++){
                for (j=0;j<dim;j++)
                    printf ("%lf ", tTaylor[j][k]);
                printf("\n");
                }
	    printf ("\n");
 
                for (i=0;i<dim;i++){
                    for (j=0;j<dim;j++)
                        printf ("%lf ", tJac[i][j][1]);
                    printf ("\n");
                    }

// Store taylor series into a MATLAB variable
/*
		plhs[0] = mxCreateDoubleMatrix(deg+1,dim,mxREAL);
		p1 = mxGetPr(plhs[0]);
		for(i=0;i<dim;i++) for(j=0;j<=deg;j++) p1[j+i*(deg+1)] = Taylor[i][j];
*/

// Store Jacobian path into a MATLAB Cell Array
/*
		plhs[1] = mxCreateCellMatrix(1,deg+1);

		for(i=0;i<=deg;i++){
			subs[0] = 0; 
			subs[1] = i;
			index = mxCalcSingleSubscript(plhs[1],2,subs);
			cell_ptr = mxCreateDoubleMatrix(dim,dim,mxREAL);
			p1 = mxGetPr(cell_ptr);
			for(j=0; j<dim; j++) for(k=0; k<dim; k++) p1[j+k*dim] = Jac[j][k][i];
			mxSetCell(plhs[1],index,cell_ptr);
		}
*/
	}

}
