#include <math.h>
#ifdef __cplusplus

#include "adouble.h"
#include "adutils.h"

#endif

#ifdef __cplusplus

void fullcubic(unsigned short tag, double *px, double *pxp, double *p)
{
    adouble xv[4];
    adouble xp[2];
    int i;

    trace_on(tag);
    for (i=0;i<2;i++)
   	xv[i] <<= px[i];
    for (i=2;i<4;i++)
        xv[i] <<= p[i-2];

xp[0] = (xv[1] - xv[0]*xv[0] -xv[0]*xv[0]*xv[0])/xv[3];
xp[1] = (xv[2] - xv[0]);
 
    for (i=0;i<2;i++)
	xp[i] >>= pxp[i];

    trace_off();
}


#endif

void fullcubic(double *px, double *pxp, double *p)
{
    double x[4];    
    double xp[2];
    int i;
 
    for (i=0;i<2;i++)        
        x[i] = px[i];
    for (i=2;i<4;i++)
        x[i] = p[i-2];

xp[0] = (xv[1] - xv[0]*xv[0] -xv[0]*xv[0]*xv[0])/xv[3];
xp[1] = (xv[2] - xv[0]);
  
    for (i=0;i<2;i++)
        pxp[i] = xp[i];
 
 
}


#ifndef __cplusplus
 
void cubic_jacobian(double *x, double **J, double *p)
{
    J[0][0] = (2.0*x[0] - 3.0*x[0]*x[0])/p[1];
    J[0][1] = 1.0/p[1];
    J[1][0] = -1.0;
    J[1][1] = 0.0;
}
 
 
#endif

