% Continuation loop: decimation and refinement outside cycle computations

% Allocate space for output

param_out = zeros(csteps,size(param,2));
data_out = cell(csteps, 1);

% Show all cycles simultaneously

hold on;

% Loop over continuation steps

for ic = 1:csteps

%Test convergence

	[nd, jd] = wcycle(data);
	err = nd(:,2:dim+1) - data(:,2:dim+1);
	nd1 = nd;
	pmm =  max(max(abs(err)));
	if pmm > pmtol 	

% Newton iteration since not converged
		ndata = data;
		[nd1,pmm] = wnewt(ndata);
		if pmm > pmtol
%Iteration did not converge: quit, but should fix data and try again
			error('Newton did not converge');
		end;
	end;

% Update data and write output

      	param_out(ic,:) = param;
      	data_out{ic} = nd1;

% Plot cycle (every fourth one)

	if mod(ic,4) == 3
      	pdata = wplot(nd1);
	end
      	drawnow;
		
% Print diagnostics

        	nn = size(nd1,1) - 1
		param = param
		period = nd1(nn+1,1)

% Update data

	ndr = wrefine(nd1);
	data = wdecimate(ndr);
	newsize = size(data,1)

% Continuation step		
 
	cdata = data;
	cparam = param;
	wcstep;
	data = cndata;
	param = cnparam;
end;
