%Continuation step

%Check accuracy of cycle

	[nd, jd] = wcycle(cdata);
	err = nd(:,2:dim+1) - cdata(:,2:dim+1);
	pmm =  max(max(abs(err)))

nint = size(cdata,1) - 1;

%Compute vector field at mesh points

vfield = zeros(nint+1,dim);
for i = 1:(nint+1)
        [tay, jmat] = fullt(cdata(i,2:dim+1),param,2);
	vfield(i,:) = tay(2,:);
end

%Begin to build Jacobian JA

JA = zeros(nint*(dim+1),nint*(dim+1)+1);

% time shifts of mesh points

JA(dim*nint+2:(dim+1)*nint,dim*nint+1:(dim+1)*nint-1) = eye(nint-1);
JA(dim*nint+1,dim*nint+1:(dim+1)*nint-1) = -ones(1,nint-1);

% i = 1 rows

JA(1:dim,1:dim) = jd{1}(:,1:dim);
JA(1:dim,dim+1:2*dim) = -eye(dim); 
JA(1:dim,dim*nint+1) = vfield(2,:)';
JA(dim*nint+1,1:dim) = vfield(1,:);
JA(1:dim,nint*(dim+1)+1) = jd{1}(:,dim+aparam);

% intermediate rows

for i = 2:nint-1
	JA(dim*(i-1)+1:dim*i,dim*(i-1)+1:dim*i) = jd{i}(:,1:dim);
	JA(dim*(i-1)+1:dim*i,dim*i+1:dim*(i+1)) = -eye(dim);
	JA(dim*(i-1)+1:dim*i,nint*(dim+1)+1) = jd{i}(:,dim+aparam);
	JA(nint*dim+i,dim*(i-1)+1:dim*i) = vfield(i,:);
	JA(dim*(i-1)+1:dim*i,nint*dim+i-1) = - vfield(i+1,:)';
	JA(dim*(i-1)+1:dim*i,nint*dim+i) = vfield(i+1,:)';
end;

% i = nint rows

JA(dim*(nint-1)+1:dim*nint,dim*(nint-1)+1:dim*nint) = jd{nint}(:,1:dim);
JA(dim*(nint-1)+1:dim*nint,1:dim) = -eye(dim);
JA(dim*(nint-1)+1:dim*nint,nint*(dim+1)+1) = jd{nint}(:,dim+aparam);
JA(nint*(dim+1),dim*(nint-1)+1:dim*nint) = vfield(nint,:);
JA(dim*(nint-1)+1:dim*nint,nint*(dim+1)-1) = - vfield(nint+1,:)';
JA(dim*(nint-1)+1:dim*nint,nint*(dim+1)) = vfield(nint+1,:)';

%compute null space for Jacobian: normalized step direction

cv = null(JA);
pt_inc =  (reshape(cv(1:dim*nint,1),dim,nint))';

%Check direction of step relative to current orbit and correct

dir = vfield(1:nint,1).*pt_inc(:,2)-vfield(1:nint,2).*pt_inc(:,1);
[dia, di] = max(abs(dir))
if dir(di) < 0
	cv = -cv;
end;
update = cv(nint*(dim+1):nint*(dim+1)+1)'

%Update data

pt_inc =  (reshape(cv(1:dim*nint,1),dim,nint))';
t_inc = cv(dim*nint+1:(dim+1)*nint,1);
cndata = cdata;
cnparam = cparam;
cndata(1:nint,2:dim+1) = cndata(1:nint,2:dim+1) + tinc*pt_inc;
cndata(nint+1,2:dim+1) = cndata(1,2:dim+1);
cndata(2:nint+1,1) = cndata(2:nint+1,1)+ tinc*t_inc;
cnparam(aparam) = cnparam(aparam)+tinc*cv((dim+1)*nint+1);

%Check mismatch of updated data 

%	[nd, jd] = wcycle(cndata);
%	err = nd(:,2:dim+1) - cndata(:,2:dim+1);
%	cpmm =  max(max(abs(err)))



	
