%Decimate mesh: Compute from point to point.
%Remove points where Jacobian norm is < cmax and endpoint matches next 
%mesh point within dtol

function [nd] = wdecimate(ldata)

global degree c dim cmax epmax hmin param dtol linc

pt = zeros(1,dim);
ndata = ldata(1,:);
pdim = size(param,2);
firststep = 1;
x = ldata(1,2:dim+1);
nd(1,:) = ldata(1,:);
jpt = [eye(dim),zeros(dim,pdim)];
sl = (size(ldata,1));

for i=1:(sl-1)
	tstop = (ldata(i+1,1) - ldata(i,1));
	wstep;
	if (norm(jpt) > cmax) | (norm(x- ldata(i+1,2:dim+1)) > dtol)
		if firststep == 0
			nd = [nd;ldata(i,:)];
			x = ldata(i,2:dim+1);
			jpt = [eye(dim),zeros(dim,pdim)];
			tstop = (ldata(i+1,1) - ldata(i,1));
			wstep;
			if (norm(jpt) > cmax) | (norm(x- ldata(i+1,2:dim+1)) > dtol)
				nd = [nd;ldata(i+1,:)];
				jpt = [eye(dim),zeros(dim,pdim)];
				x = ldata(i+1,2:dim+1);
				firststep = 1;
	
			end;
		else
			nd = [nd;ldata(i+1,:)];
			jpt = [eye(dim),zeros(dim,pdim)];
			x = ldata(i+1,2:dim+1);
			firststep = 1;
		end;
	else
		firststep = 0;
	end;
end;	
sn = size(nd,1)
if nd(sn,1) < ldata(sl,1)
	nd = [nd;ldata(sl,:)];
end;
