%
% setup for Canard calculation. initial degree is 40.
%

clear

% Global variables:
% dim is the dimension of the phase space (without time)
% data is an array of size (nint+1,dim) that holds the discrete periodic orbit
% degree is the degree of the local Taylor series expansions
% del is the length of the interval
%

global dim data sections ninterp degree wt wtd c epmax hmin cmax param x  pmtol linc aparam nsteps dtol tay_l

format long e

%load data 
load -ascii data_in2;

degree = 40;
dim = 2;


%load points into data
data = data_in2;
cdata = data;
nint = size(data(1)) - 1;

% Interval increment constant
linc = -16*log(10)/degree;

% Set global variables

%System parameters
c = -3.775733514085724e-04
eps = 0.001;
param = [c, eps];
cparam = param;

%Active parameter
aparam = 1;

%Maximum norm of Jacobian per mesh interval used in refinement and decimation
cmax = 100;

% Error tolerance comparing tangent at end of Taylor polynomial with 
% vector field
epmax = 1e-12;

% Minimum step length along trajectory
hmin = 1e-10;

% Tolerance for matching mesh points to endpoints of Taylor polynomials
pmtol  = 1e-13;

% Number of continuation steps
csteps = 225;

% Steplength of continuation steps along tangent to solution paths
tinc = -0.01;

% Maximum number of steps in Newton iteration
nsteps = 40;

% Tolerance for matching mesh points to endpoints of Taylor polynomials
% in decimation
dtol = 10^(-13);
